<?php

declare(strict_types=1);

namespace Drupal\fs_integration\Event;

use Drupal\Component\EventDispatcher\Event;
use Frontkom\GraphqlClient\Query;

/**
 * A base class for events related to GraphQL queries.
 */
abstract class QueryEvent extends Event {

  public function __construct(
    private Query $query,
  ) {}

  /**
   * Get the GraphQL query associated with this event.
   */
  public function getQuery(): Query {
    return $this->query;
  }

  /**
   * Set the GraphQL query for this event.
   */
  public function setQuery(Query $query) {
    $this->query = $query;
  }

}
